//+------------------------------------------------------------------+
//|                                 Hello Pages, Inc. -- Pyramid MACD|
//|                                                 Copyright  2008 |
//|                                        http://www.hellopages.com |
//+------------------------------------------------------------------+
//
#property copyright "http://ForexRanger.com Copyright  2008"
#property link      "http://www.ForexRanger.com"

extern int    uniquePyramidMagic = 444444; 
                                        
extern double Lots = 0.01;             
extern double PyramidSize = 10;            
extern double PyramidSteps = 4;           
extern double TakeProfit = 1200;       
extern double StopLoss = 10;           
extern int    trailStop = 10;          
extern double UpdateInterval = 1;      
extern bool   wantLongs = true;        
extern bool   wantShorts = true;       
extern bool   wantBreakout = true;     
extern bool   wantCounter = false;     
extern bool   limitEMA = true;         
extern int    EMAperiod = 34;          
extern double PyramidMaxOpen = 0;         
extern bool   UseMACD = true;          
                                       
extern bool   UseOsMA = false;          
                                       
extern bool CloseOpenPositions = false;
extern bool   doHouseKeeping = true;   
extern double keepOpenTimeLimit = 0;   
extern int    emaFast = 12;            
extern int    emaSlow = 26;            
extern int    signalPeriod = 9;        
extern int    timeFrame = 0;           
extern int    minFromPrice = 0;        

string PyramidName = "Pyramid";              
double LastUpdate = 0;                 
static double SLots=0;
static int FTime=0;

int init()
  {
 
 #property show_inputs                     

   return(0);
  }


bool IsPosition(double atRate, double inRange, bool checkLongs )
  {
     int totalorders = OrdersTotal();
     for(int i=0;i<totalorders;i++)                                
      {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == uniquePyramidMagic) || (OrderComment() == PyramidName)) ) 
         {  int type = OrderType();
            if (MathAbs( OrderOpenPrice() - atRate ) < (inRange*0.9)) 
              { if ( ( checkLongs && ( type == OP_BUY || type == OP_BUYLIMIT  || type == OP_BUYSTOP ) )  || (!checkLongs && ( type == OP_SELL || type == OP_SELLLIMIT  || type == OP_SELLSTOP ) ) )
                 { 
                    return(true); 
                 }
              }
         }
      } 
   return(false);
  }


void DeleteAfter( double xHours )    
  {
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);

     if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == uniquePyramidMagic) || (OrderComment() == PyramidName)) )  
        {
            if (( MathAbs(iTime(Symbol(),5,0)-OrderOpenTime()) >= xHours*60*60 ) && (iTime(Symbol(),5,0)>0))
            {  bool result = false;
               
               if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
               
               if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
               
               if ( OrderType() > 1 ) result = OrderDelete( OrderTicket() );
           }
        }
	  
  } 




void CloseAllPendingOrders( )
  {
     int totalorders = OrdersTotal();
     for(int i=totalorders-1;i>=0;i--)                                
      {
        OrderSelect(i, SELECT_BY_POS);
        
        if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == uniquePyramidMagic) || (OrderComment() == PyramidName)) )  
         {  
          if ( OrderType() > 1 ) bool result = OrderDelete( OrderTicket() );
         }
      } 
   return;
  }


void ClosePendingOrdersAndPositions()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;

    if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == uniquePyramidMagic) || (OrderComment() == PyramidName)) )  
     {
           
           if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
           
           if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
           
           if ( OrderType() > 1 ) result = OrderDelete( OrderTicket() );
      }
  }
  return;
}

void CloseOrdersfromEMA( double theEMAValue )
  {
     int totalorders = OrdersTotal();
     for(int i=totalorders-1;i>=0;i--)                                
      {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == uniquePyramidMagic) || (OrderComment() == PyramidName)) )  
         {  
          int type = OrderType();
          bool result = false;

          if ( type == OP_BUYLIMIT && OrderOpenPrice() <= theEMAValue ) result = OrderDelete( OrderTicket() ); 
          if ( type == OP_BUYSTOP && OrderOpenPrice() <= theEMAValue ) result = OrderDelete( OrderTicket() ); 
          if ( type == OP_SELLLIMIT && OrderOpenPrice() >= theEMAValue ) result = OrderDelete( OrderTicket() ); 
          if ( type == OP_SELLSTOP && OrderOpenPrice() >= theEMAValue ) result = OrderDelete( OrderTicket() ); 
         }
      } 
   return;
  }



int openPositions(  )
  {  int op =0;
     int totalorders = OrdersTotal();
     for(int i=totalorders-1;i>=0;i--)                                
      {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == uniquePyramidMagic) || (OrderComment() == PyramidName)) ) 
         {  
          int type = OrderType();
          if ( type == OP_BUY ) {op=op+1;} 
          if ( type == OP_SELL ) {op=op+1;} 
          if ( op > 3) {SLots = 0;}
         }
      } 
   return(op);
  }



void TrailIt( int byPips ) 
  {
  if (byPips >=5)
  {
  for (int i = 0; i < OrdersTotal(); i++) {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if ( OrderSymbol()==Symbol() && ( (OrderMagicNumber() == uniquePyramidMagic) || (OrderComment() == PyramidName)) )  
        {
            if (OrderType() == OP_BUY) {
              
               if (Bid - OrderOpenPrice() > byPips * MarketInfo(OrderSymbol(), MODE_POINT)) {
                  if (OrderStopLoss() < Bid - byPips * MarketInfo(OrderSymbol(), MODE_POINT)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - byPips * MarketInfo(OrderSymbol(), MODE_POINT), OrderDelete( OrderTicket() ), Red);
                  }
               }
            } else if (OrderType() == OP_SELL) {
               if (OrderOpenPrice() - Ask > byPips * MarketInfo(OrderSymbol(), MODE_POINT)) {
                  if ((OrderStopLoss() > Ask + byPips * MarketInfo(OrderSymbol(), MODE_POINT)) || 
                        (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(),
                        Ask + byPips * MarketInfo(OrderSymbol(), MODE_POINT), OrderDelete( OrderTicket() ), Red);
                  }
               }
            }
        }
	  }
  }

} 



int start()
  {
 
   int    i, j,k, ticket, entermode, totalorders;
   bool   doit;
   double point, startrate, traderate;

   if (FTime==0)
   {
      FTime=99;
      SLots=Lots;
   }

 if ( TakeProfit <= 0 )                 
   { TakeProfit = PyramidSize; }

 bool myWantLongs = wantLongs;
 bool myWantShorts = wantShorts;

//----

  if (MathAbs(CurTime()-LastUpdate)> UpdateInterval*60)           
   {
   LastUpdate = CurTime();
   point = MarketInfo(Symbol(),MODE_POINT);
   startrate = ( Ask + point*PyramidSize/2 ) / point / PyramidSize;   
   k = startrate ;
   k = k * PyramidSize ;
   startrate = k * point - PyramidSize*PyramidSteps/2*point ;          
   double myEMA=iMA(NULL,0,EMAperiod,0,MODE_EMA,PRICE_CLOSE,0);
   int currentOpen = 0;
   if ( PyramidMaxOpen > 0 ) {
      currentOpen = openPositions();
      if (currentOpen >= PyramidMaxOpen) {CloseAllPendingOrders(); }
   }
   
   if (limitEMA) { if (doHouseKeeping) CloseOrdersfromEMA(myEMA);}
   if (keepOpenTimeLimit > 0) DeleteAfter(keepOpenTimeLimit);
   if (trailStop >0) TrailIt(trailStop);
   if ( UseMACD || UseOsMA)  
     {
      if ( UseMACD ) 
        {
            double Trigger0=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,0);
            double Trigger1=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,1);
            double Trigger2=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,2);
        }
      if ( UseOsMA ) 
        {
             Trigger0=iOsMA(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,0);
             Trigger1=iOsMA(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,1);
             Trigger2=iOsMA(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,2);
        }
        
       if( Trigger0>0 && Trigger1>0  &&  Trigger2<0)     
        {
         CloseAllPendingOrders();
         if ( CloseOpenPositions == true ) { ClosePendingOrdersAndPositions(); }
        }
       if( Trigger0<0 && Trigger1<0  &&  Trigger2>0)     
        {
         CloseAllPendingOrders();
         if ( CloseOpenPositions == true ) { ClosePendingOrdersAndPositions(); }
        }
       myWantLongs = false;
       myWantShorts = false;
       if( Trigger0>0 && Trigger1>0  &&  Trigger2>0 && wantLongs )     
        {
         myWantLongs = true;
        }
       if( Trigger0<0 && Trigger1<0  &&  Trigger2<0 && wantShorts )    
        {
         myWantShorts = true;
        }
   }
   int myPyramidSteps = PyramidSteps;
   if (( PyramidMaxOpen > 0 ) && (currentOpen >= PyramidMaxOpen)) {
      myPyramidSteps = 0;
   }
   for( i=0;i<myPyramidSteps;i++)
   {
     traderate = startrate + i*point*PyramidSize;
     if ( myWantLongs && (!limitEMA || traderate > myEMA))
       {
         if ( IsPosition(traderate,point*PyramidSize,true) == false )          
          {
            double myStopLoss = 0;
             if ( StopLoss > 0 )
               { myStopLoss = traderate-point*StopLoss ; }
             if ( traderate > Ask ) 
              { entermode = OP_BUYSTOP; } 
              else 
              { entermode = OP_BUYLIMIT ; } 
              if ( ((traderate > (Ask +minFromPrice*Point) ) && (wantBreakout)) || ((traderate <= (Ask-minFromPrice*Point) ) && (wantCounter)) ) 
              { 
                 
                 ticket=OrderSend(Symbol(),entermode,SLots,traderate,0,myStopLoss,traderate+point*TakeProfit,PyramidName,uniquePyramidMagic,0,Green); 
                 if(ticket>=0)
                 {
                    if(SLots<=10.0)
                    {
                      SLots=SLots*3;
                    }
                    else 
                    {
                      SLots=Lots;
                    }                                        
                 }
                 
             }
          }
       }
     if ( myWantShorts && (!limitEMA || traderate < myEMA))
       {
         if (IsPosition(traderate,point*PyramidSize,false)== false )           
          {
             myStopLoss = 0;
             if ( StopLoss > 0 )
               { myStopLoss = traderate+point*StopLoss ; }
             if ( traderate > Bid ) 
              { entermode = OP_SELLLIMIT; } 
              else 
              { entermode = OP_SELLSTOP ; } 
              
              if ( ((traderate < (Bid -minFromPrice*Point) ) && (wantBreakout)) || ((traderate >= (Bid+minFromPrice*Point) ) && (wantCounter)) ) 
                { 
                   
                   ticket=OrderSend(Symbol(),entermode,SLots,traderate,0,myStopLoss,traderate-point*TakeProfit,PyramidName,uniquePyramidMagic,0,Red); 
                   if(ticket>=0)
                     {
                        if(SLots<=10)
                        {
                          SLots=SLots*3; 
                        }
                        else
                        {
                        SLots=Lots;
                        }
                     }  
                }
          }
       }
    }
   }
   return(0);
  }

